import { login, logout, getInfo, refreshToken, getPhoneCode, isLogin } from '@/api/login'
import { getToken, setToken, setExpiresIn, removeToken } from '@/utils/auth'

const user = {
  state: {
    token: getToken(),
    id: '',
    name: '',
    avatar: '',
    roles: [],
    permissions: []
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_EXPIRES_IN: (state, time) => {
      state.expires_in = time
    },
    SET_ID: (state, id) => {
      state.id = id
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    }
  },

  actions: {
    IsLogin({ commit }, userInfo) {
      let payload = {}
      const loginType = userInfo.loginType
      if (loginType === 'password') {
        payload = {
          username: userInfo.username.trim(),
          password: userInfo.password,
          uuid: userInfo.uuid,
          code: userInfo.code,
          loginType: loginType
        }
      } else if (loginType === 'mobile') {
        payload = {
          mobile: userInfo.mobile.trim(),
          verificationCode: userInfo.verificationCode,
          uuid: userInfo.uuid,
          code: userInfo.code,
          loginType: loginType
        }
      }
      return new Promise((resolve, reject) => {
        isLogin(payload).then(res => {
          resolve(res);
        }).catch(error => {
          reject(error)
        })
      })
    },
    // 登录
    Login({ commit }, userInfo) {
      let payload = {}
      const loginType = userInfo.loginType
      if (loginType === 'password') {
        payload = {
          username: userInfo.username.trim(),
          password: userInfo.password,
          uuid: userInfo.uuid,
          code: userInfo.code,
          loginType: loginType
        }
      } else if (loginType === 'mobile') {
        payload = {
          mobile: userInfo.mobile.trim(),
          verificationCode: userInfo.verificationCode,
          uuid: userInfo.uuid,
          code: userInfo.code,
          loginType: loginType
        }
      }
      return new Promise((resolve, reject) => {
        login(payload).then(res => {
          let data = res.data
          setToken(data.access_token)
          commit('SET_TOKEN', data.access_token)
          setExpiresIn(data.expires_in)
          commit('SET_EXPIRES_IN', data.expires_in)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },
    GetPhoneCode({ commit }, userInfo) {
      let payload = {}
      payload = {
        mobile: userInfo.mobile.trim(),
        uuid: userInfo.uuid,
        code: userInfo.code,
        mobileCodeType: userInfo.mobileCodeType
      }
      return new Promise((resolve, reject) => {
        getPhoneCode(payload).then(res => {
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },
    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(res => {
          const user = res.user
          const avatar = (user.avatar == '' || user.avatar == null) ? require('@/assets/images/profile.jpg') : user.avatar
          if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.roles)
            commit('SET_PERMISSIONS', res.permissions)
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT'])
          }
          commit('SET_ID', user.userId)
          commit('SET_NAME', user.userName)
          commit('SET_AVATAR', avatar)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 刷新token
    RefreshToken({ commit, state }) {
      return new Promise((resolve, reject) => {
        refreshToken(state.token).then(res => {
          setExpiresIn(res.data)
          commit('SET_EXPIRES_IN', res.data)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '')
          commit('SET_ROLES', [])
          commit('SET_PERMISSIONS', [])
          removeToken()
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
